(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (factory((global.Alfa = {}),global.React));
}(this, (function (exports,React) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  /*!
   * isobject <https://github.com/jonschlinkert/isobject>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   */

  var isobject = function isObject(val) {
    return val != null && typeof val === 'object' && Array.isArray(val) === false;
  };

  /**
   * The Store class. It's a key value store with simple subscription support.
   */

  var Store =
  /*#__PURE__*/
  function () {
    /**
     * Constructor
     */
    function Store(data) {
      var _this = this;

      _classCallCheck(this, Store);

      _defineProperty(this, "isAlfaStore", true);

      _defineProperty(this, "silentVersion", 0);

      _defineProperty(this, "setWithOutputs", function (outputs) {
        var set = _this.set;
        return function checkOutputAndSet(key, value, maps) {
          if (isobject(key)) {
            Object.keys(key).forEach(function (_key) {
              checkOutputAndSet(_key, key[_key], maps);
            });
            return;
          }

          if (Array.isArray(outputs) && outputs.indexOf(key) === -1) {
            // Throw exception if the output key is not allowed.
            throw new Error("Output key \"".concat(key, "\" is not allowed. You need to define it as an output when calling inject/subscribe."));
          }

          if (maps && maps[key]) {
            key = maps[key];
          }

          set(key, value);
        };
      });

      _defineProperty(this, "clone", function () {
        var cloned = {};
        var _store = _this._store;
        Object.keys(_store).forEach(function (key) {
          return cloned[key] = _store[key];
        });
        return cloned;
      });

      _defineProperty(this, "subscribe", function (keys, fn, maps) {
        if ('function' !== typeof fn) {
          throw new TypeError('`fn` must be a function');
        }

        if (maps) {
          fn.maps = maps;
        }

        var _subscriptions = _this._subscriptions;
        Array.isArray(keys) && keys.forEach(function (key) {
          var subs = _subscriptions[key];

          if (Array.isArray(subs)) {
            subs.indexOf(key) === -1 && subs.push(fn);
          } else {
            _subscriptions[key] = [fn];
            return;
          }
        });
      });

      _defineProperty(this, "unsubscribe", function (fn) {
        var _subscriptions = _this._subscriptions;
        Object.keys(_subscriptions).forEach(function (key) {
          var subs = _subscriptions[key];
          subs && (_subscriptions[key] = subs.filter(function (f) {
            return f !== fn;
          }));
        });
      });

      /**
       * Internal object which holds the key/value map.
       * @type {Object}
       */
      this._store = {};
      /**
       * Internal object which holds all the subscription functions.
       * @type {Object}
       */

      this._subscriptions = {};
      this.set = this.set.bind(this); // Initial store if we have data.

      data && this.set(data);
    }
    /**
     * @type {Boolean}
     */


    _createClass(Store, [{
      key: "get",

      /**
       * Get value from store by key.
       *
       * @param  {String|undefined} key Name of the value to get.
       * @return {Any}        Value.
       */
      value: function get(key) {
        var keyType = _typeof(key);

        var _store = this._store;

        if ('string' === keyType) {
          return _store[key];
        } else if (Array.isArray(key) && key.length > 0) {
          var results = {};
          key.forEach(function (k) {
            if ('string' === typeof k) {
              if (_store.hasOwnProperty(k)) {
                results[k] = _store[k];
              }
            } else {
              throw new TypeError('Type of `key` must be string, array of strings or undefined.');
            }
          });
          return results;
        } else if ('undefined' === keyType) {
          return this.clone();
        } else {
          throw new TypeError('Type of `key` must be string, array of strings or undefined.');
        }
      }
      /**
       * Save the `value` in store with name `key`.
       *
       * @param {String|Object}   key   Name of the value in store.  Or object of
       * key/value pairs to merge into the store.
       * @param {Any}             value Value to save.
       * @param {Boolean}         silent set to true to avoid calling subscription
       *                          functions.
       */

    }, {
      key: "set",
      value: function set(key, value, silent) {
        var store = this;

        if ('string' === typeof key) {
          setSingle(store, key, value, silent);
        } else if (isobject(key)) {
          Object.keys(key).forEach(function (_key) {
            setSingle(store, _key, key[_key], silent);
          });
        } else {
          throw new TypeError('Type of `key` must be string or plain object.');
        }
      }
    }]);

    return Store;
  }();

  function setSingle(store, key, value, silent) {
    var _store = store._store,
        _subscriptions = store._subscriptions; // Uncurry alfa action functions

    if (typeof value === 'function' && value.alfaAction) {
      value = value.alfaAction(store);
    } // Save the value to the store.


    _store[key] = value;

    if (silent) {
      store.silentVersion += 1;
      return;
    } // Call subscribed functions if we have.


    var subs = _subscriptions[key];

    if (subs) {
      var changed = _defineProperty({}, key, value);

      subs.forEach(function (subFn) {
        // Make sure the subFn is still legit at the time we are calling it since
        // all subscribing functions are actually `setStat`.  And previous
        // `setState` calls could trigger unmount component which later `setState`
        // belongs to.
        // Need to make the below code reproducible by test.
        // var _subs = subscriptions[key]
        // if (_subs.indexOf(subFn) === -1) {
        //   return
        // }
        if (subFn.maps) {
          var maps = subFn.maps;
          Object.keys(maps).some(function (injectKey) {
            var realKey = maps[injectKey];

            if (realKey === key) {
              changed = _defineProperty({}, injectKey, value);
              return true;
            }

            return false;
          });
        }

        subFn(changed);
      });
    }
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  /*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  */
  /* eslint-disable no-unused-vars */
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var hasOwnProperty = Object.prototype.hasOwnProperty;
  var propIsEnumerable = Object.prototype.propertyIsEnumerable;

  function toObject(val) {
  	if (val === null || val === undefined) {
  		throw new TypeError('Object.assign cannot be called with null or undefined');
  	}

  	return Object(val);
  }

  function shouldUseNative() {
  	try {
  		if (!Object.assign) {
  			return false;
  		}

  		// Detect buggy property enumeration order in older V8 versions.

  		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
  		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
  		test1[5] = 'de';
  		if (Object.getOwnPropertyNames(test1)[0] === '5') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test2 = {};
  		for (var i = 0; i < 10; i++) {
  			test2['_' + String.fromCharCode(i)] = i;
  		}
  		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
  			return test2[n];
  		});
  		if (order2.join('') !== '0123456789') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test3 = {};
  		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
  			test3[letter] = letter;
  		});
  		if (Object.keys(Object.assign({}, test3)).join('') !==
  				'abcdefghijklmnopqrst') {
  			return false;
  		}

  		return true;
  	} catch (err) {
  		// We don't expect any of the above to throw, but better to be safe.
  		return false;
  	}
  }

  var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
  	var from;
  	var to = toObject(target);
  	var symbols;

  	for (var s = 1; s < arguments.length; s++) {
  		from = Object(arguments[s]);

  		for (var key in from) {
  			if (hasOwnProperty.call(from, key)) {
  				to[key] = from[key];
  			}
  		}

  		if (getOwnPropertySymbols) {
  			symbols = getOwnPropertySymbols(from);
  			for (var i = 0; i < symbols.length; i++) {
  				if (propIsEnumerable.call(from, symbols[i])) {
  					to[symbols[i]] = from[symbols[i]];
  				}
  			}
  		}
  	}

  	return to;
  };

  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  var printWarning = function() {};

  {
    var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
    var loggedTypeFailures = {};

    printWarning = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  /**
   * Assert that the values match with the type specs.
   * Error messages are memorized and will only be shown once.
   *
   * @param {object} typeSpecs Map of name to a ReactPropType
   * @param {object} values Runtime values that need to be type-checked
   * @param {string} location e.g. "prop", "context", "child context"
   * @param {string} componentName Name of the component for error messages.
   * @param {?Function} getStack Returns the component stack.
   * @private
   */
  function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
    {
      for (var typeSpecName in typeSpecs) {
        if (typeSpecs.hasOwnProperty(typeSpecName)) {
          var error;
          // Prop type validation may throw. In case they do, we don't want to
          // fail the render phase where it didn't fail before. So we log it.
          // After these have been cleaned up, we'll let them throw.
          try {
            // This is intentionally an invariant that gets caught. It's the same
            // behavior as without this statement except with a better message.
            if (typeof typeSpecs[typeSpecName] !== 'function') {
              var err = Error(
                (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
                'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
              );
              err.name = 'Invariant Violation';
              throw err;
            }
            error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
          } catch (ex) {
            error = ex;
          }
          if (error && !(error instanceof Error)) {
            printWarning(
              (componentName || 'React class') + ': type specification of ' +
              location + ' `' + typeSpecName + '` is invalid; the type checker ' +
              'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
              'You may have forgotten to pass an argument to the type checker ' +
              'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
              'shape all require an argument).'
            );

          }
          if (error instanceof Error && !(error.message in loggedTypeFailures)) {
            // Only monitor this failure once because there tends to be a lot of the
            // same error.
            loggedTypeFailures[error.message] = true;

            var stack = getStack ? getStack() : '';

            printWarning(
              'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
            );
          }
        }
      }
    }
  }

  var checkPropTypes_1 = checkPropTypes;

  var printWarning$1 = function() {};

  {
    printWarning$1 = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  function emptyFunctionThatReturnsNull() {
    return null;
  }

  var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
    /* global Symbol */
    var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

    /**
     * Returns the iterator method function contained on the iterable object.
     *
     * Be sure to invoke the function with the iterable as context:
     *
     *     var iteratorFn = getIteratorFn(myIterable);
     *     if (iteratorFn) {
     *       var iterator = iteratorFn.call(myIterable);
     *       ...
     *     }
     *
     * @param {?object} maybeIterable
     * @return {?function}
     */
    function getIteratorFn(maybeIterable) {
      var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
      if (typeof iteratorFn === 'function') {
        return iteratorFn;
      }
    }

    /**
     * Collection of methods that allow declaration and validation of props that are
     * supplied to React components. Example usage:
     *
     *   var Props = require('ReactPropTypes');
     *   var MyArticle = React.createClass({
     *     propTypes: {
     *       // An optional string prop named "description".
     *       description: Props.string,
     *
     *       // A required enum prop named "category".
     *       category: Props.oneOf(['News','Photos']).isRequired,
     *
     *       // A prop named "dialog" that requires an instance of Dialog.
     *       dialog: Props.instanceOf(Dialog).isRequired
     *     },
     *     render: function() { ... }
     *   });
     *
     * A more formal specification of how these methods are used:
     *
     *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
     *   decl := ReactPropTypes.{type}(.isRequired)?
     *
     * Each and every declaration produces a function with the same signature. This
     * allows the creation of custom validation functions. For example:
     *
     *  var MyLink = React.createClass({
     *    propTypes: {
     *      // An optional string or URI prop named "href".
     *      href: function(props, propName, componentName) {
     *        var propValue = props[propName];
     *        if (propValue != null && typeof propValue !== 'string' &&
     *            !(propValue instanceof URI)) {
     *          return new Error(
     *            'Expected a string or an URI for ' + propName + ' in ' +
     *            componentName
     *          );
     *        }
     *      }
     *    },
     *    render: function() {...}
     *  });
     *
     * @internal
     */

    var ANONYMOUS = '<<anonymous>>';

    // Important!
    // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
    var ReactPropTypes = {
      array: createPrimitiveTypeChecker('array'),
      bool: createPrimitiveTypeChecker('boolean'),
      func: createPrimitiveTypeChecker('function'),
      number: createPrimitiveTypeChecker('number'),
      object: createPrimitiveTypeChecker('object'),
      string: createPrimitiveTypeChecker('string'),
      symbol: createPrimitiveTypeChecker('symbol'),

      any: createAnyTypeChecker(),
      arrayOf: createArrayOfTypeChecker,
      element: createElementTypeChecker(),
      instanceOf: createInstanceTypeChecker,
      node: createNodeChecker(),
      objectOf: createObjectOfTypeChecker,
      oneOf: createEnumTypeChecker,
      oneOfType: createUnionTypeChecker,
      shape: createShapeTypeChecker,
      exact: createStrictShapeTypeChecker,
    };

    /**
     * inlined Object.is polyfill to avoid requiring consumers ship their own
     * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
     */
    /*eslint-disable no-self-compare*/
    function is(x, y) {
      // SameValue algorithm
      if (x === y) {
        // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return x !== 0 || 1 / x === 1 / y;
      } else {
        // Step 6.a: NaN == NaN
        return x !== x && y !== y;
      }
    }
    /*eslint-enable no-self-compare*/

    /**
     * We use an Error-like object for backward compatibility as people may call
     * PropTypes directly and inspect their output. However, we don't use real
     * Errors anymore. We don't inspect their stack anyway, and creating them
     * is prohibitively expensive if they are created too often, such as what
     * happens in oneOfType() for any type before the one that matched.
     */
    function PropTypeError(message) {
      this.message = message;
      this.stack = '';
    }
    // Make `instanceof Error` still work for returned errors.
    PropTypeError.prototype = Error.prototype;

    function createChainableTypeChecker(validate) {
      {
        var manualPropTypeCallCache = {};
        var manualPropTypeWarningCount = 0;
      }
      function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
        componentName = componentName || ANONYMOUS;
        propFullName = propFullName || propName;

        if (secret !== ReactPropTypesSecret_1) {
          if (throwOnDirectAccess) {
            // New behavior only for users of `prop-types` package
            var err = new Error(
              'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
              'Use `PropTypes.checkPropTypes()` to call them. ' +
              'Read more at http://fb.me/use-check-prop-types'
            );
            err.name = 'Invariant Violation';
            throw err;
          } else if (typeof console !== 'undefined') {
            // Old behavior for people using React.PropTypes
            var cacheKey = componentName + ':' + propName;
            if (
              !manualPropTypeCallCache[cacheKey] &&
              // Avoid spamming the console because they are often not actionable except for lib authors
              manualPropTypeWarningCount < 3
            ) {
              printWarning$1(
                'You are manually calling a React.PropTypes validation ' +
                'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
                'and will throw in the standalone `prop-types` package. ' +
                'You may be seeing this warning due to a third-party PropTypes ' +
                'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
              );
              manualPropTypeCallCache[cacheKey] = true;
              manualPropTypeWarningCount++;
            }
          }
        }
        if (props[propName] == null) {
          if (isRequired) {
            if (props[propName] === null) {
              return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
            }
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
          }
          return null;
        } else {
          return validate(props, propName, componentName, location, propFullName);
        }
      }

      var chainedCheckType = checkType.bind(null, false);
      chainedCheckType.isRequired = checkType.bind(null, true);

      return chainedCheckType;
    }

    function createPrimitiveTypeChecker(expectedType) {
      function validate(props, propName, componentName, location, propFullName, secret) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== expectedType) {
          // `propValue` being instance of, say, date/regexp, pass the 'object'
          // check, but we can offer a more precise error message here rather than
          // 'of type `object`'.
          var preciseType = getPreciseType(propValue);

          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createAnyTypeChecker() {
      return createChainableTypeChecker(emptyFunctionThatReturnsNull);
    }

    function createArrayOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
        }
        var propValue = props[propName];
        if (!Array.isArray(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
        }
        for (var i = 0; i < propValue.length; i++) {
          var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createElementTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        if (!isValidElement(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createInstanceTypeChecker(expectedClass) {
      function validate(props, propName, componentName, location, propFullName) {
        if (!(props[propName] instanceof expectedClass)) {
          var expectedClassName = expectedClass.name || ANONYMOUS;
          var actualClassName = getClassName(props[propName]);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createEnumTypeChecker(expectedValues) {
      if (!Array.isArray(expectedValues)) {
        printWarning$1('Invalid argument supplied to oneOf, expected an instance of array.');
        return emptyFunctionThatReturnsNull;
      }

      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        for (var i = 0; i < expectedValues.length; i++) {
          if (is(propValue, expectedValues[i])) {
            return null;
          }
        }

        var valuesString = JSON.stringify(expectedValues);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createObjectOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
        }
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
        }
        for (var key in propValue) {
          if (propValue.hasOwnProperty(key)) {
            var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
            if (error instanceof Error) {
              return error;
            }
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createUnionTypeChecker(arrayOfTypeCheckers) {
      if (!Array.isArray(arrayOfTypeCheckers)) {
        printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.');
        return emptyFunctionThatReturnsNull;
      }

      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (typeof checker !== 'function') {
          printWarning$1(
            'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
            'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
          );
          return emptyFunctionThatReturnsNull;
        }
      }

      function validate(props, propName, componentName, location, propFullName) {
        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];
          if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
            return null;
          }
        }

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createNodeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        if (!isNode(props[propName])) {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        for (var key in shapeTypes) {
          var checker = shapeTypes[key];
          if (!checker) {
            continue;
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createStrictShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        // We need to check all keys in case some are required but missing from
        // props.
        var allKeys = objectAssign({}, props[propName], shapeTypes);
        for (var key in allKeys) {
          var checker = shapeTypes[key];
          if (!checker) {
            return new PropTypeError(
              'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
              '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
              '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
            );
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function isNode(propValue) {
      switch (typeof propValue) {
        case 'number':
        case 'string':
        case 'undefined':
          return true;
        case 'boolean':
          return !propValue;
        case 'object':
          if (Array.isArray(propValue)) {
            return propValue.every(isNode);
          }
          if (propValue === null || isValidElement(propValue)) {
            return true;
          }

          var iteratorFn = getIteratorFn(propValue);
          if (iteratorFn) {
            var iterator = iteratorFn.call(propValue);
            var step;
            if (iteratorFn !== propValue.entries) {
              while (!(step = iterator.next()).done) {
                if (!isNode(step.value)) {
                  return false;
                }
              }
            } else {
              // Iterator will provide entry [k,v] tuples rather than values.
              while (!(step = iterator.next()).done) {
                var entry = step.value;
                if (entry) {
                  if (!isNode(entry[1])) {
                    return false;
                  }
                }
              }
            }
          } else {
            return false;
          }

          return true;
        default:
          return false;
      }
    }

    function isSymbol(propType, propValue) {
      // Native Symbol.
      if (propType === 'symbol') {
        return true;
      }

      // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
      if (propValue['@@toStringTag'] === 'Symbol') {
        return true;
      }

      // Fallback for non-spec compliant Symbols which are polyfilled.
      if (typeof Symbol === 'function' && propValue instanceof Symbol) {
        return true;
      }

      return false;
    }

    // Equivalent of `typeof` but with special handling for array and regexp.
    function getPropType(propValue) {
      var propType = typeof propValue;
      if (Array.isArray(propValue)) {
        return 'array';
      }
      if (propValue instanceof RegExp) {
        // Old webkits (at least until Android 4.0) return 'function' rather than
        // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
        // passes PropTypes.object.
        return 'object';
      }
      if (isSymbol(propType, propValue)) {
        return 'symbol';
      }
      return propType;
    }

    // This handles more types than `getPropType`. Only used for error messages.
    // See `createPrimitiveTypeChecker`.
    function getPreciseType(propValue) {
      if (typeof propValue === 'undefined' || propValue === null) {
        return '' + propValue;
      }
      var propType = getPropType(propValue);
      if (propType === 'object') {
        if (propValue instanceof Date) {
          return 'date';
        } else if (propValue instanceof RegExp) {
          return 'regexp';
        }
      }
      return propType;
    }

    // Returns a string that is postfixed to a warning about an invalid type.
    // For example, "undefined" or "of type array"
    function getPostfixForTypeWarning(value) {
      var type = getPreciseType(value);
      switch (type) {
        case 'array':
        case 'object':
          return 'an ' + type;
        case 'boolean':
        case 'date':
        case 'regexp':
          return 'a ' + type;
        default:
          return type;
      }
    }

    // Returns class name of the object, if any.
    function getClassName(propValue) {
      if (!propValue.constructor || !propValue.constructor.name) {
        return ANONYMOUS;
      }
      return propValue.constructor.name;
    }

    ReactPropTypes.checkPropTypes = checkPropTypes_1;
    ReactPropTypes.PropTypes = ReactPropTypes;

    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  {
    var REACT_ELEMENT_TYPE = (typeof Symbol === 'function' &&
      Symbol.for &&
      Symbol.for('react.element')) ||
      0xeac7;

    var isValidElement = function(object) {
      return typeof object === 'object' &&
        object !== null &&
        object.$$typeof === REACT_ELEMENT_TYPE;
    };

    // By explicitly using `prop-types` you are opting into new development behavior.
    // http://fb.me/prop-types-in-prod
    var throwOnDirectAccess = true;
    module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
  }
  });

  /**
   * Public API
   */

  var inject = createInjector('inject', createAlfaInjectedComponent);
  var subscribe = createInjector('subscribe', createAlfaSubscribedComponent);
  /**
   * Private functions
   */

  function createInjector(type, creator) {
    return function (WrappedComponent, inputs, outputs) {
      if (typeof WrappedComponent === 'function') {
        var componentName = WrappedComponent.name;
        inputs = normalizeInputs(componentName, inputs, WrappedComponent.keys);
        outputs = normalizeOutputs(componentName, inputs, outputs);
        return creator(WrappedComponent, inputs, outputs);
      } else {
        // istanbul ignore next
        var error = "alfa.".concat(type, " only accepts function or class. Got \"").concat(_typeof(WrappedComponent), "\".");
        throw new TypeError(error);
      }
    };
  }

  function normalizeInputs(name, inputs, dynamicInputs) {
    if (inputs && 'string' === typeof inputs) {
      return [inputs];
    } else if (Array.isArray(inputs)) {
      return inputs;
    } else if ('function' === typeof dynamicInputs) {
      return [];
    } else {
      throw new TypeError("".concat(name, ": inject/subscribe only accepts string or array of strings as second parameter (inputs) when static property 'keys' of component does not exist."));
    }
  }
  function normalizeOutputs(name, inputs, outputs) {
    // Check if output keys are provided when `set` is required as input key.
    if (Array.isArray(inputs) && inputs.indexOf('set') > -1 && (!Array.isArray(outputs) || 0 === outputs.length)) {
      throw new Error("".concat(name, ": outputs are required as 3rd argument of function \"inject/subscribe\" when \"set\" is injected/subscribed."));
    }

    if (outputs) {
      // When we have key(s) of output we need to check the type(s) of all the keys.
      if ('string' === typeof outputs) {
        // The outputs is a string then normalize it as an array.
        return [outputs];
      }

      if (Array.isArray(outputs) && outputs.every(function (key) {
        return typeof key === 'string';
      })) {
        // Outputs is an array, make sure all the elements of this array are string.
        return outputs;
      } // Throw exception if any key of the outputs is not supported.


      throw new TypeError("".concat(name, ": inject/subscribe only accepts string or array of strings as 3rd parameter (outputs)."));
    }
  }

  function createAlfaInjectedComponent(WrappedComponent, inputs, outputs) {
    var keys = WrappedComponent.keys;

    function AlfaInjectedComponent(props, context, updater) {
      var alfaStore = context && context.alfaStore;
      var injectedProps = getInjectedProps(inputs, outputs, alfaStore); // Props passed in directly to constructor has lower priority than inputs
      // injected from the store.

      var _props = _objectSpread({}, props, injectedProps);

      if (keys) {
        var dynamicInputs = getDynamicInputs(keys, _props, inputs);
        _props = getDynamicProps(dynamicInputs, outputs, alfaStore);
      }

      if (WrappedComponent.prototype.isReactComponent) {
        // Create an element if it's react component.
        return React.createElement(WrappedComponent, _props);
      } else {
        // Otherwise, call the original function.
        return WrappedComponent(_props, context, updater);
      }
    }

    AlfaInjectedComponent.keys = keys;
    AlfaInjectedComponent.contextTypes = {
      alfaStore: propTypes.object
    };
    return AlfaInjectedComponent;
  }

  function createAlfaSubscribedComponent(WrappedComponent, inputs, outputs) {
    var keys = WrappedComponent.keys;

    var AlfaSubscribedComponent =
    /*#__PURE__*/
    function (_Component) {
      _inherits(AlfaSubscribedComponent, _Component);

      function AlfaSubscribedComponent(_props2, context, updater) {
        var _this;

        _classCallCheck(this, AlfaSubscribedComponent);

        // Call the original constructor.
        _this = _possibleConstructorReturn(this, _getPrototypeOf(AlfaSubscribedComponent).call(this, _props2, context, updater));
        /* istanbul ignore next */
        // Save the store for subscribe/unsubscribe.

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getState", function (props, alfaStore) {
          if (!alfaStore || _this.silentVersion === alfaStore.silentVersion) {
            return _this.state;
          } // Sync silent version with alfa store


          _this.silentVersion = alfaStore.silentVersion; // Get injected props which is part of the state of the component.

          var injectedProps = getInjectedProps(inputs, outputs, alfaStore); // Merge injected props with props where the injectedProps has higher priority.

          var _props = _objectSpread({}, props, injectedProps); // Get dynamic inputs.


          var dynamicInputs = getDynamicInputs(keys, _props, inputs);
          _this.maps = dynamicInputs.maps;
          _this.inputs = dynamicInputs.inputs; // Get the props and return as state

          return getDynamicProps(dynamicInputs, outputs, alfaStore);
        });

        _this.store = context && context.alfaStore; // Get the state.
        // console.log('silentVersion in constructor', this.silentVersion)

        _this.state = _this.getState(_props2, _this.store); // Use bound setState as subscription function.

        var setState = _this.setState.bind(_assertThisInitialized(_assertThisInitialized(_this)));

        _this.setState = function () {
          setState.apply(null, arguments);
        };

        return _this;
      }

      _createClass(AlfaSubscribedComponent, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          // Call `setState` when subscribed keys changed.
          this.store && this.store.subscribe(this.inputs, this.setState, this.maps);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          // Unsubcribe `setState` when component is about to unmount.
          this.store && this.store.unsubscribe(this.setState);
        }
      }, {
        key: "render",
        value: function render() {
          // Render the original component with state as its props.
          return React.createElement(WrappedComponent, _objectSpread({}, this.props, this.getState(this.props, this.store)));
        }
      }]);

      return AlfaSubscribedComponent;
    }(React.Component);

    _defineProperty(AlfaSubscribedComponent, "contextTypes", {
      alfaStore: propTypes.object
    });

    AlfaSubscribedComponent.keys = keys;
    return AlfaSubscribedComponent;
  }

  function getInjectedProps(inputs, outputs, alfaStore) {
    var stringInputs = inputs.filter(function (input) {
      return typeof input === 'string';
    });

    var injectedProps = _objectSpread({}, alfaStore.get(stringInputs)); // Need to inject set.


    if (inputs.indexOf('set') > -1) {
      injectedProps.set = alfaStore.setWithOutputs(outputs);
    }

    return injectedProps;
  }
  /**
   * Load dependencies with the result of calling `keys` function of the component.
   *
   * This gives people the ability to load dynamic dependencies based on the props
   * of the component at runtime.
   * It makes a map between the dynamic names of the dependencies and the names
   * of the properties injected in `state` of the component.
   * That helps maintaining a simple naming system in the application code.
   *
   * @param  {Function} keys
   * @param  {Object} props
   * @param  {Array} outputs
   * @param  {Object} alfaStore
   * @return {Object}
   */


  function getDynamicProps(_ref, outputs, alfaStore) {
    var keys = _ref.keys,
        maps = _ref.maps,
        inputs = _ref.inputs;

    var _props = getInjectedProps(inputs, outputs, alfaStore);

    if (maps) {
      keys.forEach(function (key) {
        _props[key] = _props[maps[key]];
      }); // Map outputs

      if (outputs && 'function' === typeof _props.set) {
        // The `set` of `props` which is obtained from calling
        // `alfaStore.setWithOutputs(outputs)`
        var _setWithOutputs = _props.set; // Call `_setWithOutputs` with maps if

        _props.set = function (key, value) {
          _setWithOutputs(key, value, maps);
        };
      }

      return _props;
    } else {
      // No mapped props
      return _props;
    }
  }

  function getDynamicInputs(getKeys, props, _inputs) {
    if (getKeys && 'function' === typeof getKeys) {
      var inputs = getKeys(props);

      if (Array.isArray(inputs)) {
        return {
          inputs: _toConsumableArray(_inputs).concat(_toConsumableArray(inputs))
        };
      } else if (isobject(inputs)) {
        // Object of mappings between injection keys and real input keys.
        var keys = Object.keys(inputs);
        var realInputs = keys.map(function (key) {
          return inputs[key];
        });
        return {
          keys: keys,
          maps: inputs,
          inputs: _toConsumableArray(_inputs).concat(_toConsumableArray(realInputs))
        };
      }
    }

    return {
      inputs: _inputs
    };
  }

  function action(func, inputs, outputs) {
    inputs = normalizeInputs('alfaAction', inputs);
    outputs = normalizeOutputs('alfaAction', inputs, outputs);

    func.alfaAction = function (store) {
      // const set = store.setWithOutputs(outputs)
      return function (args) {
        var input = store.get(inputs);
        input.set = store.setWithOutputs(outputs);
        var result = func(_objectSpread({}, input, args));

        if (isobject(result)) {
          input.set(result);
        }
      };
    };

    return func;
  }

  /**
   * Class to make alfa-enabled component.
   */

  var Provider =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Provider, _Component);

    function Provider(props, context) {
      var _this;

      _classCallCheck(this, Provider);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Provider).call(this, props, context));
      /* istanbul ignore next */
      // Handle different type of data.

      var data = props.data;

      if (data) {
        _this.store = data.isAlfaStore ? data : new Store(data);
      } else {
        _this.store = new Store();
      }

      return _this;
    } // Instance of alfa store as a child context.


    _createClass(Provider, [{
      key: "getChildContext",
      value: function getChildContext() {
        return {
          alfaStore: this.store
        };
      }
    }, {
      key: "render",
      value: function render() {
        return React.Children.only(this.props.children);
      }
    }]);

    return Provider;
  }(React.Component);
  /**
   * Functional interface for creating alfa-enabled component.
   *
   * @param  {Class|Function}     WrappedComponent The user component which is being wrapped.
   * @param  {Store|Object|null}  data            This could be several types:
   *    1. Instance of alfa Store which will be used directly as the internal store object.
   *    2. The initial data of the private store if it's an plain object.
   *    3. Nothing.  A private store will be created internally.
   * @return {Class}              The wrapping component.
   */

  _defineProperty(Provider, "childContextTypes", {
    alfaStore: propTypes.object.isRequired
  });

  function provide(WrappedComponent, data) {
    return function (props) {
      return React__default.createElement(Provider, {
        data: data
      }, React.createElement(WrappedComponent, props));
    };
  }

  /**
   * Export toplevel APIs.
   */

  exports.Store = Store;
  exports.action = action;
  exports.provide = provide;
  exports.Provider = Provider;
  exports.inject = inject;
  exports.subscribe = subscribe;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
